$(function() {
    var $apicker = $("#datepicker-a"),
        $bpicker = $("#datepicker-b"),
        $solopicker = $("#datepicker"),
        $pickers = $([]).add($apicker)
                        .add($bpicker)
                        .add($solopicker);
    $pickers.datepicker({
        showWeek: false,
    });
    $apicker.datepicker("option", "onSelect", function(dateText, inst) {
        var aDate = $apicker.datepicker("getDate");
        var bDate = $bpicker.datepicker("getDate");
        if ( aDate > bDate) {
            $bpicker.datepicker("setDate", aDate);
        }
        updateAPIURL();
    });
    $bpicker.datepicker("option", "onSelect", function(dateText, inst) {
        var aDate = $apicker.datepicker("getDate");
        var bDate = $bpicker.datepicker("getDate");
        if ( aDate > bDate) {
            $apicker.datepicker("setDate", bDate);
        }
        updateAPIURL();
    });
    $solopicker.datepicker("option", "onSelect", function(dateText, inst) {
        updateAPIURL();
    });
    $.getJSON("export_meta.json", function(meta) {
        if (meta.first_date !== false) {
            var lastdate = new Date(meta.last_date);
            var lastweek = new Date(lastdate.getTime() - 7 * 24 * 60 * 60000);
            $pickers.datepicker("option", "minDate", new Date(meta.first_date));
            $pickers.datepicker("option", "maxDate", lastdate);
            $apicker.datepicker("setDate", lastweek);
            $bpicker.datepicker("setDate", lastdate);
            $solopicker.datepicker("setDate", lastdate);
            updateAPIURL();
        } else {
            $pickers.datepicker("option", "minDate", new Date());
            $pickers.datepicker("option", "maxDate", new Date());
            $pickers.datepicker("option", "setDate", new Date());
            updateAPIURL();
        }
    });
    $("#date input").change(function() {
        $("#single-date").hide();
        $("#multiple-date").hide();
        if ( $("#date input[id=datepicker-single]").is(":checked") ) {
            $("#single-date").show();
            $solopicker.datepicker("setDate", $apicker.datepicker("getDate"));
        } else if ( $("#date input[id=datepicker-multi]").is(":checked") ) {
            $("#multiple-date").show();
            $apicker.datepicker("setDate", $solopicker.datepicker("getDate"));
        }
        updateAPIURL();
    }).trigger("change");
    $("#format input, #resolution input, #export-method input").change(function() {
        updateAPIURL();
    }).trigger("change");
    function updateAPIURL() {
        $("#export-api").val(createAPIURL());
    }
    function createAPIURL() {
        function pad(value, length) {
            value = String(value);
            while (value.length < length) {
                value = "0" + value;
            }
            return value;
        }
        function dateify(d) {
            return d.getFullYear() + pad(1 + d.getMonth(), 2) + pad(d.getDate(), 2);
        }
        var url = "export.";
        var $formatElement = $("#statistics-export [name=format]:checked");
        var $resolutionElement = $("#statistics-export [name=resolution]:checked");
        var $dateChoiceElement = $("#statistics-export [name=date]:checked");
        var $methodElement = $("#statistics-export [name=export-method]:checked");
        url += $formatElement.attr("id").substring(7);
        var dateValue, resolutionValue, methodValue;
        resolutionValue = $resolutionElement.attr("id").substring(11);
        methodValue = $methodElement.attr("id").substring(7);
        if ( $dateChoiceElement.attr("id") == "datepicker-single" ) {
            dateValue = dateify($solopicker.datepicker("getDate"));
        } else if ( $dateChoiceElement.attr("id") == "datepicker-multi" ) {
            var dateA = $apicker.datepicker("getDate");
            var dateB = $bpicker.datepicker("getDate");
            dateValue = dateify(dateA) + "-" + dateify(dateB);
        } else {
            dateValue = "all";
        }
        var $form = $("#export-download").parents("form");
        $form.find("[name=date]").val(dateValue);
        $form.find("[name=resolution]").val(resolutionValue);
        $form.find("[name=method]").val(methodValue);
        $form.attr("action", url);
        url += "?resolution=" + resolutionValue;
        url += "&date=" + dateValue;
        url += "&method=" + methodValue;
        return location.href.replace(/\/[^\/]*$/, "/") + url;
    }
});

