/*global $, alert */
$(function () {
    "use strict";
    /* INIT */
    var disable_enable = function (checkbox) {
        var checkbox_id = checkbox.attr("id"),
            $sibling_inputs = checkbox.parents("fieldset").find("input").filter("[enable_disable_by='" + checkbox_id + "']"),
            $filtered_sibling_inputs = $(""),
            checked = checkbox.is(":checked"),
            $parent_checkbox;
        if (typeof checkbox.attr("enable_disable_by") !== "undefined") {
            $parent_checkbox = $("#" + checkbox.attr("enable_disable_by"));
            if (!$parent_checkbox.is(":checked")) {
                // Stop sublevel enable_disable to show their inputs on init.
                return;
            }
        }
        $sibling_inputs.each(function (){
            var sublevel_checked,
                $sublevel_sibling_inputs;
            if ($(this).hasClass("enable-disable")) {
                sublevel_checked = $(this).is(":checked");
                $sublevel_sibling_inputs = $("[enable_disable_by='" + $(this).attr("id") + "']");
                if ((sublevel_checked && checked) || (!checked)) {
                    $filtered_sibling_inputs = $filtered_sibling_inputs.add($sublevel_sibling_inputs);
                }
                // TODO Add recursion to allow for more than one sublevel of enable_disable
            }
            $filtered_sibling_inputs = $filtered_sibling_inputs.add($(this));
        });
        if (checked) {
            $filtered_sibling_inputs.parent().parent(".ctrlHolder").slideDown();
        } else {
            $filtered_sibling_inputs.parent().parent(".ctrlHolder").slideUp();
        }
    };
    $("#form-settings .enable-disable").each(function() {
        disable_enable($(this));
    });

    $("#left form div.accordify").accordion({
        heightStyle: "content",
        icons: false
    });
    $("#form-settings input").each(function () {
        var name = $(this).attr("name");
        $(this).attr("data-parsley-class-handler", "#validation-wrapper-" + name);
    });

    /* Click behaviours */
    $("#left form").submit(function (e) {
        $(".ui-accordion-content").each(function () {
            if ($(this).find(".parsley-error, .validation-error").length > 0) {
                $(this).slideDown();
                e.preventDefault();
            }
        });
    });
    $("#form-settings .enable-disable").click(function () {
        disable_enable($(this));
    });
    $("#right .centered").createVideo();
    var $meta_warning;
    $("#meta_height").on('keyup', function() {
        if ( $meta_warning ) {
            $meta_warning.remove();
        }
        var val = parseInt($(this).val(), 10);
        if ( val < 240 && val >= 210 ) {
            $meta_warning = $("<p/>").insertAfter("#meta_height").addClass("parsley-warning");
            $meta_warning.text("Note that heights below 240 cm are not supported.").show();
        } else if ( val > 400 && val <= 450 ) {
            $meta_warning = $("<p/>").insertAfter("#meta_height").addClass("parsley-warning");
            $meta_warning.text("Note that heights above 400 cm are not supported.").show();
        } else {
        }
    }).trigger("keyup");
});
